GNU bug report logs - #19266
24.4; Font-related window redrawing delays on OS X

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Kirill Ignatiev <kirill.ignatiev@HIDDEN>; dated Thu, 4 Dec 2014 07:14:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 17 Dec 2014 02:13:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 16 21:13:19 2014
Received: from localhost ([127.0.0.1]:48289 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Y1474-00007w-RI
	for submit <at> debbugs.gnu.org; Tue, 16 Dec 2014 21:13:19 -0500
Received: from mail-wi0-f174.google.com ([209.85.212.174]:42757)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1Y1472-00007m-N5
 for 19266 <at> debbugs.gnu.org; Tue, 16 Dec 2014 21:13:17 -0500
Received: by mail-wi0-f174.google.com with SMTP id h11so14181577wiw.7
 for <19266 <at> debbugs.gnu.org>; Tue, 16 Dec 2014 18:13:16 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=e8J8P1L2sB2vfBD6NDo0gershLySCvyjXJJv5jXafUU=;
 b=EMM46iPMyVvKBZa4of30YZoIy6oyGB3+stWMGHVVMHLHhTy8B/ytbjdSnPqo3bod+F
 U7KfNTmFH1kGnZ590NL2qsrB7LQXtQRd0xnk4X/wj1xXzW3CV+WxdY2dZLTaxLCjE9ru
 SyCAbNqusW/lR3i1ciAiGlaApZ6eZBSl6C6ya/nHJqu3D5Mc3//eqBoyQSSalEvMMICH
 ZfBlb7TeHg0Ad0eS/qEG9u+YRRLeumP3SrwpIHd27Wfi+Dk1OCbPYVdQKKGqMFqIdG7y
 8gikZmWS2DqELPQsl4kwgwsMhySLHKg12Kghio5IkR2t9VvfV8jb9Bn0IlCj7b7wUgDS
 Bmhg==
MIME-Version: 1.0
X-Received: by 10.181.13.42 with SMTP id ev10mr9540405wid.78.1418782396235;
 Tue, 16 Dec 2014 18:13:16 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Tue, 16 Dec 2014 18:13:16 -0800 (PST)
In-Reply-To: <CACe-pWzUkX9m=NeqVbPxegr28RyFXpQ0zf85woJGzutDkpL28w@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
 <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
 <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
 <83iohhs35v.fsf@HIDDEN>
 <CACe-pWzUkX9m=NeqVbPxegr28RyFXpQ0zf85woJGzutDkpL28w@HIDDEN>
Date: Tue, 16 Dec 2014 21:13:16 -0500
Message-ID: <CACe-pWw8dYx2sAVXpFiCuk0PUMscMz+caZRAepx+6MWHT+za1Q@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: Dmitry Antipov <dmantipov@HIDDEN>,
 Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On some further testing, it seems that commenting out the section of
compact_font_caches that calls compact_font_cache_entry works (the
section surrounded in !defined(HAVE_NTGUI)). There are no more
repeated calls to font_open_entity, and fonts are not closed as
before. I am unable to reproduce the redisplay delay with the two-font
example above.

This presumably stops all cached fonts from being closed at all, ever,
so maybe there should be a more elegant solution. This could (?) be an
issue that mark_face_cache just doesn't mark enough fonts, so unused
fonts get discarded and must be loaded again. Also, this doesn't
explain why garbage-collect doesn't seem to trigger font closing.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 17 Dec 2014 01:35:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 16 20:35:34 2014
Received: from localhost ([127.0.0.1]:48285 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Y13WX-0007cP-LM
	for submit <at> debbugs.gnu.org; Tue, 16 Dec 2014 20:35:33 -0500
Received: from mail-wg0-f44.google.com ([74.125.82.44]:38697)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1Y13WV-0007cD-GF
 for 19266 <at> debbugs.gnu.org; Tue, 16 Dec 2014 20:35:32 -0500
Received: by mail-wg0-f44.google.com with SMTP id b13so19050099wgh.31
 for <19266 <at> debbugs.gnu.org>; Tue, 16 Dec 2014 17:35:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=uYDhc/yiWs09eI2XyCal6nC0PpIEwdlkhwVQRi/ovg8=;
 b=nWkdToO5JdxnvqinuyvgUoioOyZuUa5rvPRSr74oUO0kS70HJ1WbI3O3R9/G+1QdK3
 zyGLSs2OfZIzAFfeqvk3+XXWigj8wYJoZ9LYRN8/W5Hjr2y2pH3RN9RyGMWfoSvikWRq
 04fPSvrAZvc7k+msMA6I3tP5bS4OwqiFFU/bgEHRFeajCw9IrgMSEUvCLfn9Wx/tMACl
 iAEt0eHquBQuhbfDGBt+nW7YM3D8X0GS3BhLkN1DuyhRdoJiUVr6c9fSYe+muZk5EMZW
 cH9bR87hXxlODMG+sde8XhK66HzpaOHGRutA0ugoL1E3oLrmwqAUt2C2ROU0ZBMy+XsU
 DyAQ==
MIME-Version: 1.0
X-Received: by 10.180.88.33 with SMTP id bd1mr9521141wib.10.1418780130917;
 Tue, 16 Dec 2014 17:35:30 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Tue, 16 Dec 2014 17:35:30 -0800 (PST)
In-Reply-To: <83iohhs35v.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
 <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
 <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
 <83iohhs35v.fsf@HIDDEN>
Date: Tue, 16 Dec 2014 20:35:30 -0500
Message-ID: <CACe-pWzUkX9m=NeqVbPxegr28RyFXpQ0zf85woJGzutDkpL28w@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: Dmitry Antipov <dmantipov@HIDDEN>,
 Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 12 December 2014 at 03:06, Eli Zaretskii <eliz@HIDDEN> wrote:
> Look up the call chain (best done by setting a breakpoint and looking
> at the backtrace), and you will certainly find a place which decides
> to discard them.  Then comment out or change the code which does that.
>
> ...
>
> Again, look at the backtrace at a breakpoint in cleanup_vector and in
> compact_font_cache_entry.  Isn't there some GC-related function on the
> callstack?  Perhaps post that here, if you cannot figure that out.

The top function is garbage_collect, but whatever leads it to close
the fonts isn't triggered by a manual call to garbage-collect in
emacs.

Also: if the garbage collector isn't wrong, the fact that font
entities are garbage means that it really is okay to close them: they
wouldn't be accessible to all the other code anyway. I don't quite
understand how font_open_entity decides to load a font against using a
cache, but making sure fonts remain accessible to the call path

face_for_char -> fontset_font -> fontset_find_font -> font_open_entity

is probably the thing to do. Setting compact_font_cache_entry to a
noop doesn't seem to do the trick, font_open_entity gets called too
many times anyway, if I'm not mistaken.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 12 Dec 2014 10:57:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 12 05:57:02 2014
Received: from localhost ([127.0.0.1]:43517 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XzNuA-00051B-66
	for submit <at> debbugs.gnu.org; Fri, 12 Dec 2014 05:57:02 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:63525)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1XzNu2-00050j-BS
 for 19266 <at> debbugs.gnu.org; Fri, 12 Dec 2014 05:56:59 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
 a-mtaout23.012.net.il (HyperSendmail v2007.08) id
 <0NGG00600U4XQ500@HIDDEN> for 19266 <at> debbugs.gnu.org;
 Fri, 12 Dec 2014 12:56:47 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout23.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NGG006WKUEFL780@HIDDEN>;
 Fri, 12 Dec 2014 12:56:39 +0200 (IST)
Date: Fri, 12 Dec 2014 12:56:41 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <CACe-pWw=eHNZq13v-P0V0Ojbe3N23gmOxt4TxNoGEVFeD4Lg0A@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
Message-id: <83bnn9rv9y.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN> <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
 <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
 <02C00883-A844-4E95-8E1B-6F7860E03B63@HIDDEN>
 <CACe-pWw=eHNZq13v-P0V0Ojbe3N23gmOxt4TxNoGEVFeD4Lg0A@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: dmantipov@HIDDEN, swiesner@HIDDEN, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Date: Fri, 12 Dec 2014 04:33:06 -0500
> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, Dmitry Antipov <dmantipov@HIDDEN>, 19266 <at> debbugs.gnu.org
> 
> I tried unicode-fonts now, and it does seem to fix the delays. Thanks!
> But I still think there's a problem: my configuration, which led to
> these delays, and my other example with one default font and one
> special font for uncommon symbols, are both perfectly ordinary and
> simple configurations. I'd say they shouldn't cause these kinds of
> problems at all. In particular, unicode-fonts is not actually part of
> emacs, so it's reasonable to expect emacs to work well enough without
> it.

You are encouraged to continue investigating this problem and
reporting your findings here.  It's quite possible that there's
something we need to fix, as the font releasing process was changed
lately, and could likely need improvements.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 12 Dec 2014 09:33:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 12 04:33:16 2014
Received: from localhost ([127.0.0.1]:43506 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XzMb5-0002yb-Eq
	for submit <at> debbugs.gnu.org; Fri, 12 Dec 2014 04:33:15 -0500
Received: from mail-wg0-f53.google.com ([74.125.82.53]:40888)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XzMb3-0002yP-Dv
 for 19266 <at> debbugs.gnu.org; Fri, 12 Dec 2014 04:33:13 -0500
Received: by mail-wg0-f53.google.com with SMTP id l18so8623007wgh.12
 for <19266 <at> debbugs.gnu.org>; Fri, 12 Dec 2014 01:33:07 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type:content-transfer-encoding;
 bh=zmS97E3O6EWmkkFOhlKA0vq68Fr0AXxQgrFOU91Jsks=;
 b=xPtJO9OixIGnJwsXY8++cQDCU+21eUbNkq5yBv5AGz9DnFnYpWiCIJCKQyEWnuTIBg
 zWrwURkjCP1Gm4b+RsNhJdW10G/Y+IZ4+SItvS2HNu1paJvFGawZ40qHjb03BEvresSm
 PVf4YR4ety6Yo1aLfRaf4cFnJrwSzTb8Ezp0XFSfNGJvJcIWc5iHlWlK550tjXJVpADe
 4Mc7beO6G1vUgHu6mYuoqUC8x4Nd42YzPIh+nYM+evbv9Inv8YTWKZf+tj+DAvGyAcsE
 PV70x9Hn+lLIaj6rzy0SWCu1hgdRVR1liSlViVV8d8wffmhvK7iKubdoJ+4Qf3yhAaue
 P1Xg==
MIME-Version: 1.0
X-Received: by 10.181.13.42 with SMTP id ev10mr5753457wid.78.1418376786699;
 Fri, 12 Dec 2014 01:33:06 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Fri, 12 Dec 2014 01:33:06 -0800 (PST)
In-Reply-To: <02C00883-A844-4E95-8E1B-6F7860E03B63@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
 <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
 <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
 <02C00883-A844-4E95-8E1B-6F7860E03B63@HIDDEN>
Date: Fri, 12 Dec 2014 04:33:06 -0500
Message-ID: <CACe-pWw=eHNZq13v-P0V0Ojbe3N23gmOxt4TxNoGEVFeD4Lg0A@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Sebastian Wiesner <swiesner@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: Eli Zaretskii <eliz@HIDDEN>, Dmitry Antipov <dmantipov@HIDDEN>,
 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 12 December 2014 at 03:29, Sebastian Wiesner <swiesner@HIDDEN> wr=
ote:
>
>> Am 12.12.2014 um 03:10 schrieb Kirill Ignatiev <kirill.ignatiev@HIDDEN=
m>:
>>
>> On 11 December 2014 at 12:45, Eli Zaretskii <eliz@HIDDEN> wrote:
>>>> Date: Wed, 10 Dec 2014 18:50:01 -0500
>>>> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
>>>> Cc: Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
>>>
>>> Comment out the call to cleanup_vector?
>>
>> =E2=80=A6
>>
>> Thanks for your help, these redrawing delays are really irritating.
>
> You have long lost me on your discussion about Emacs internals, but I sho=
uld just like to say that the unicode-fonts package from https://github.com=
/rolandwalker/unicode-fonts has fixed all these delays for me.

I tried unicode-fonts now, and it does seem to fix the delays. Thanks!
But I still think there's a problem: my configuration, which led to
these delays, and my other example with one default font and one
special font for uncommon symbols, are both perfectly ordinary and
simple configurations. I'd say they shouldn't cause these kinds of
problems at all. In particular, unicode-fonts is not actually part of
emacs, so it's reasonable to expect emacs to work well enough without
it.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 12 Dec 2014 08:30:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 12 03:30:02 2014
Received: from localhost ([127.0.0.1]:43497 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XzLbt-0001Rs-Ii
	for submit <at> debbugs.gnu.org; Fri, 12 Dec 2014 03:30:02 -0500
Received: from vega.uberspace.de ([95.143.172.245]:55324)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <swiesner@HIDDEN>) id 1XzLbq-0001Rh-RG
 for 19266 <at> debbugs.gnu.org; Fri, 12 Dec 2014 03:29:59 -0500
Received: (qmail 27176 invoked from network); 12 Dec 2014 08:29:55 -0000
Received: from localhost (HELO ?IPv6:2001:a60:16fb:1801:240d:1e27:54d7:54c1?)
 (127.0.0.1)
 by vega.uberspace.de with SMTP; 12 Dec 2014 08:29:55 -0000
Content-Type: text/plain; charset=utf-8
Mime-Version: 1.0 (Mac OS X Mail 8.1 \(1993\))
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Sebastian Wiesner <swiesner@HIDDEN>
In-Reply-To: <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
Date: Fri, 12 Dec 2014 09:29:52 +0100
Content-Transfer-Encoding: quoted-printable
Message-Id: <02C00883-A844-4E95-8E1B-6F7860E03B63@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN> <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
 <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
X-Mailer: Apple Mail (2.1993)
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 19266
Cc: Eli Zaretskii <eliz@HIDDEN>, Dmitry Antipov <dmantipov@HIDDEN>,
 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)


> Am 12.12.2014 um 03:10 schrieb Kirill Ignatiev =
<kirill.ignatiev@HIDDEN>:
>=20
> On 11 December 2014 at 12:45, Eli Zaretskii <eliz@HIDDEN> wrote:
>>> Date: Wed, 10 Dec 2014 18:50:01 -0500
>>> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
>>> Cc: Sebastian Wiesner <swiesner@HIDDEN>, =
19266 <at> debbugs.gnu.org
>>=20
>> Comment out the call to cleanup_vector?
>=20
> =E2=80=A6
>=20
> Thanks for your help, these redrawing delays are really irritating.

You have long lost me on your discussion about Emacs internals, but I =
should just like to say that the unicode-fonts package from =
https://github.com/rolandwalker/unicode-fonts has fixed all these delays =
for me.

As far as I understand, this package maps Unicode blocks to specific =
fonts.  I presume that Emacs would otherwise search through all =
installed fonts for one that supports the Unicode character that needs =
to be drawn, and that the explicit mapping prevents Emacs from doing =
that.

Seems that Eli was right with his =E2=80=9CFix your font =
configuration=E2=80=9D remark.

Thanks for your help and your effort!=




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 12 Dec 2014 08:06:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 12 03:06:28 2014
Received: from localhost ([127.0.0.1]:43485 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XzLF5-0000tI-R4
	for submit <at> debbugs.gnu.org; Fri, 12 Dec 2014 03:06:28 -0500
Received: from mtaout22.012.net.il ([80.179.55.172]:57987)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1XzLF3-0000sy-A4
 for 19266 <at> debbugs.gnu.org; Fri, 12 Dec 2014 03:06:26 -0500
Received: from conversion-daemon.a-mtaout22.012.net.il by
 a-mtaout22.012.net.il (HyperSendmail v2007.08) id
 <0NGG00900M6NN900@HIDDEN> for 19266 <at> debbugs.gnu.org;
 Fri, 12 Dec 2014 10:06:19 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout22.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NGG009B2MIIFE70@HIDDEN>;
 Fri, 12 Dec 2014 10:06:19 +0200 (IST)
Date: Fri, 12 Dec 2014 10:06:20 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
Message-id: <83iohhs35v.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN> <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
 <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: dmantipov@HIDDEN, swiesner@HIDDEN, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Date: Thu, 11 Dec 2014 21:10:32 -0500
> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> Cc: Dmitry Antipov <dmantipov@HIDDEN>, Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
> 
> On 11 December 2014 at 12:45, Eli Zaretskii <eliz@HIDDEN> wrote:
> >> Date: Wed, 10 Dec 2014 18:50:01 -0500
> >> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> >> Cc: Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
> >
> > Comment out the call to cleanup_vector?
> 
> Oops, I only tried to turn compact_font_cache_entry into a noop. But
> neither that, nor doing nothing in cleanup_vector works. If I comment
> out drv->close, I see a bunch of calls to drv->close not being made,
> but new fonts are *still* being opened in font_open_entity.
> 
> I'm guessing that when fonts are garbage collected, they are already
> genuinely discarded, not pointed to from elisp structures (or where
> they are stored), and are genuine garbage. Do you know where the
> pointers to fonts live? I haven't figured out where they are being
> discarded, and I'd like to stop them from becoming garbage in the
> first place.

Look up the call chain (best done by setting a breakpoint and looking
at the backtrace), and you will certainly find a place which decides
to discard them.  Then comment out or change the code which does that.

> >> How do I trigger font garbage collection manually?
> >
> > Did you try "M-x garbage-collect RET"?
> 
> Yes, but it doesn't seem to trigger closing fonts. Perhaps there is
> some other process at work there?

Again, look at the backtrace at a breakpoint in cleanup_vector and in
compact_font_cache_entry.  Isn't there some GC-related function on the
callstack?  Perhaps post that here, if you cannot figure that out.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 12 Dec 2014 02:10:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 11 21:10:41 2014
Received: from localhost ([127.0.0.1]:43388 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XzFgn-000613-9O
	for submit <at> debbugs.gnu.org; Thu, 11 Dec 2014 21:10:41 -0500
Received: from mail-wg0-f47.google.com ([74.125.82.47]:41276)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XzFgj-00060p-RF
 for 19266 <at> debbugs.gnu.org; Thu, 11 Dec 2014 21:10:38 -0500
Received: by mail-wg0-f47.google.com with SMTP id n12so7890815wgh.6
 for <19266 <at> debbugs.gnu.org>; Thu, 11 Dec 2014 18:10:32 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=+lLa3JtTQF6cDzH8zUl5F8fUCnrbb2QBy3Hhqe9/cxg=;
 b=ghKp8OS9g71jQTI0xY8Gu9HxeiR4tWbSs7AMmDVZTjRby5Ir8ZAvdeylf3Ha9t17+a
 4kTzp5GcseSmInS05zIE8u4jZ/OgWv8p/J2aT7E/6mo1mihWfc+yikhxqj9CAwTBiolw
 SORELScImRn/r/Uv6BwpW2Doyw+aCsfKKvOCjY8UnASz+7Iy7pG9EHaH5WzCigYmLzYu
 lLAliD04PyexSSrD2ere6F/EfIqDTZFks87B6l5JzzB/otc3SDbUBQO3uARRrDVEeXQQ
 61baiYW2fOjKIaXfIo0mne4apyc4W8IAyWHbZ2ocWN6F6Rru033NoPMngnIPtGPmgi0H
 xhHA==
MIME-Version: 1.0
X-Received: by 10.194.249.70 with SMTP id ys6mr21772076wjc.61.1418350232309;
 Thu, 11 Dec 2014 18:10:32 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Thu, 11 Dec 2014 18:10:32 -0800 (PST)
In-Reply-To: <8361dit70g.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
 <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
 <8361dit70g.fsf@HIDDEN>
Date: Thu, 11 Dec 2014 21:10:32 -0500
Message-ID: <CACe-pWykeS7AMdetb1j7dvoMbpi56-Cibw6NJdCkmkU3s2G4CA@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: Dmitry Antipov <dmantipov@HIDDEN>,
 Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 11 December 2014 at 12:45, Eli Zaretskii <eliz@HIDDEN> wrote:
>> Date: Wed, 10 Dec 2014 18:50:01 -0500
>> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
>> Cc: Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
>
> Comment out the call to cleanup_vector?

Oops, I only tried to turn compact_font_cache_entry into a noop. But
neither that, nor doing nothing in cleanup_vector works. If I comment
out drv->close, I see a bunch of calls to drv->close not being made,
but new fonts are *still* being opened in font_open_entity.

I'm guessing that when fonts are garbage collected, they are already
genuinely discarded, not pointed to from elisp structures (or where
they are stored), and are genuine garbage. Do you know where the
pointers to fonts live? I haven't figured out where they are being
discarded, and I'd like to stop them from becoming garbage in the
first place.

>
>> How do I trigger font garbage collection manually?
>
> Did you try "M-x garbage-collect RET"?

Yes, but it doesn't seem to trigger closing fonts. Perhaps there is
some other process at work there?

Thanks for your help, these redrawing delays are really irritating.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 11 Dec 2014 17:45:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 11 12:45:49 2014
Received: from localhost ([127.0.0.1]:43026 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Xz7o9-0001OR-Vh
	for submit <at> debbugs.gnu.org; Thu, 11 Dec 2014 12:45:49 -0500
Received: from mtaout24.012.net.il ([80.179.55.180]:43581)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1Xz7o6-0001O9-Ce
 for 19266 <at> debbugs.gnu.org; Thu, 11 Dec 2014 12:45:43 -0500
Received: from conversion-daemon.mtaout24.012.net.il by mtaout24.012.net.il
 (HyperSendmail v2007.08) id <0NGF00J00HYFU000@HIDDEN> for
 19266 <at> debbugs.gnu.org; Thu, 11 Dec 2014 19:37:48 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by mtaout24.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NGF00I79IB0X720@HIDDEN>; Thu, 11 Dec 2014 19:37:48 +0200 (IST)
Date: Thu, 11 Dec 2014 19:45:35 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>,
 Dmitry Antipov <dmantipov@HIDDEN>
Message-id: <8361dit70g.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN> <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
 <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: swiesner@HIDDEN, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Date: Wed, 10 Dec 2014 18:50:01 -0500
> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> Cc: Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
> 
> Can someone familiar with emacs' font internals check if this makes
> sense as the cause of the problem, please? I really don't understand
> how/where fonts are stored/cached/used; I did read
> font/fontset/macfont/alloc.c, but I'm still unclear.

Unfortunately, we don't have too many experts on this, to put it
mildly.  Dmitry, could you please take a look?

> To summarize: My interpretation of what's happening is that when emacs
> looks at some fonts to see if they contain a certain characters and
> neither of them does, emacs *does not* cache the fonts. So the next
> time redisplay happens after those fonts are garbage-collected, emacs
> has to load the fonts all over again, causing a noticeable redisplay
> delay.

This does sound like the truth, although I'm not sure.

> For testing, how do I turn off font garbage collection, so that no
> font is ever closed?

Comment out the call to cleanup_vector?

> How do I trigger font garbage collection manually?

Did you try "M-x garbage-collect RET"?

> Is this the right mailing list for this?

Yes, it is.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 10 Dec 2014 23:50:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 10 18:50:11 2014
Received: from localhost ([127.0.0.1]:42124 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Xyr1F-0005QQ-LW
	for submit <at> debbugs.gnu.org; Wed, 10 Dec 2014 18:50:10 -0500
Received: from mail-wi0-f178.google.com ([209.85.212.178]:45674)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1Xyr1D-0005QD-Lf
 for 19266 <at> debbugs.gnu.org; Wed, 10 Dec 2014 18:50:08 -0500
Received: by mail-wi0-f178.google.com with SMTP id em10so6887817wid.11
 for <19266 <at> debbugs.gnu.org>; Wed, 10 Dec 2014 15:50:02 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=KgTsSeL8XiVgR7g7z27E3HIOCw19yuSalxd5C5n1tOE=;
 b=ca3UEH7+6ewoXihLfnrGcE9LRxv585nDle43RcoPny9trSC9ytqjdUCUdH1ZO5YHLF
 fLe6UzCI2CYWxvEPXhmBybf/tDMtdX/4AVl/c3WzTjDkGLTWTxDKwHZb/eslcTv3Bjl4
 icEI6a9JGo6Wm/6bqKdYuFgnGb59qZNAVYb19TSmxSIPHxfhSBu++3CvsArZEie3TCp5
 BwbccB45eGYPsoEKRukijsg/0Q0GoOTgvTMYwCsplzwn+X4bTiqP6qsA9qP+SQAZZu+7
 cmF9jZqbzSpfq8djDwtkvhLSFrR5/hmT/C9rKXY3jYG2gjKpnFmrYx1kG/EJv7BT0IpZ
 yggw==
MIME-Version: 1.0
X-Received: by 10.180.12.75 with SMTP id w11mr17766929wib.9.1418255401937;
 Wed, 10 Dec 2014 15:50:01 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Wed, 10 Dec 2014 15:50:01 -0800 (PST)
In-Reply-To: <83fvcrzbku.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
 <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
 <83fvcrzbku.fsf@HIDDEN>
Date: Wed, 10 Dec 2014 18:50:01 -0500
Message-ID: <CACe-pWxphaJdwqnb8qXuqZJwDKH4nc2HP1Rv7t=Xyi41Vh2y4g@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/mixed; boundary=001a11c23d286f09ee0509e55185
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: Sebastian Wiesner <swiesner@HIDDEN>, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--001a11c23d286f09ee0509e55185
Content-Type: text/plain; charset=UTF-8

Can someone familiar with emacs' font internals check if this makes
sense as the cause of the problem, please? I really don't understand
how/where fonts are stored/cached/used; I did read
font/fontset/macfont/alloc.c, but I'm still unclear.

To summarize: My interpretation of what's happening is that when emacs
looks at some fonts to see if they contain a certain characters and
neither of them does, emacs *does not* cache the fonts. So the next
time redisplay happens after those fonts are garbage-collected, emacs
has to load the fonts all over again, causing a noticeable redisplay
delay.

Shouldn't these fonts be cached as well?

For testing, how do I turn off font garbage collection, so that no
font is ever closed?

How do I trigger font garbage collection manually?

Is this the right mailing list for this?

So now:

Apply the attached patch that traces every call to
font_driver->{open,close} with printf, *no actual changes*. I tested
this on OS X, maybe it's the same on linux. Now consider the following
commands, executed in patched emacs with -Q:

(set-fontset-font
 t '(#x1d400 . #x1d7ff)
 (font-xlfd-name (find-font (font-spec :family "Symbola"))))

(progn
  (insert ?\n)
  (dotimes (i (- #x1d800 #x1d400))
    (insert (+ #x1d400 i)))
  (insert ?\n))

Here, Symbola is a font that includes uncommon characters
#x1d400..#x1d7ff (not all of that range is valid unicode characters),
while the font chosen by emacs by default ("Menlo", there's nothing
special about it, I think) does not. On a different computer with different
fonts, you might need to set some other fonts.

For reference, the font specs are (from describe-fontset)
    -*-Symbola-normal-normal-semicondensed-*-*-*-*-*-p-0-iso10646-1
    -*-Menlo-normal-normal-normal-*-*-*-*-*-m-0-fontset-startup

This example uses invalid characters (rather than characters missing
from Symbola) because Symbola includes a lot of characters, and my
previous testing suggested that if I pick a font that actually misses
some characters the results are the same, but then I have to try to
also figure out which exact characters are missing, which is very
font-dependent. Invalid characters are always missing.

It seems to be those characters not present in either Symbola or the
default font that are causing delays.

I run emacs with -Q, and execute those two commands in the scratch
buffer.  The output is this:

font_open_entity: 0x10280fe30 4336959717 0 => 4321797773
font_open_entity: 0x10280fe30 4322249501 12 => 4322240165
font_open_entity: 0x10280fe30 4322249381 12 => 4322313893
compact_font_cache_entry: dropped 2 entries
cleanup_vector: drv->close 0x101a026a0
font_open_entity: 0x10280fe30 4346667037 12 => 4346773157
font_open_entity: 0x10280fe30 4321497117 12 => 4322359973
compact_font_cache_entry: dropped 1 entries
cleanup_vector: drv->close 0x101a146a0
font_open_entity: 0x10280fe30 4346850893 12 => 4346855205
font_open_entity: 0x10280fe30 4346855581 12 => 4338042813
font_open_entity: 0x10280fe30 4346864757 12 => 4347020349
font_open_entity: 0x10280fe30 4314058597 12 => 4314214573
font_open_entity: 0x10280fe30 4314313573 12 => 4314346005
font_open_entity: 0x10280fe30 4314342253 12 => 4314776629
font_open_entity: 0x10280fe30 4338539877 12 => 4338731989
font_open_entity: 0x10280fe30 4338728301 12 => 4315110181
font_open_entity: 0x10280fe30 4315102573 12 => 4338889725
font_open_entity: 0x10280fe30 4315401573 12 => 4315429429
font_open_entity: 0x10280fe30 4337120613 12 => 4339102261
font_open_entity: 0x10280fe30 4339702117 12 => 4339661005
font_open_entity: 0x10280fe30 4339664797 12 => 4339599381
font_open_entity: 0x10280fe30 4339591533 7 => 4315644109
compact_font_cache_entry: dropped 15 entries

The number of font_open_entity seems to correspond to the number of
different fonts on my computer matching the default font spec, or
something like this.  None of them contain missing characters.  Now I
go to, say, emacs/src/font.c, scroll up and down for a while (I'm not
sure how this garbage collection is triggered, I'd rather trigger it
manually but I don't know how), and eventually I get this:

font_open_entity: 0x10280fe30 4347168317 12 => 4347168797
font_open_entity: 0x10280fe30 4347168557 12 => 4347247269
compact_font_cache_entry: dropped 1 entries
cleanup_vector: drv->close 0x1013b80c8
cleanup_vector: drv->close 0x102a9f8c8
cleanup_vector: drv->close 0x102a90810
cleanup_vector: drv->close 0x102a17230
cleanup_vector: drv->close 0x101383a30
cleanup_vector: drv->close 0x1029e33f8
cleanup_vector: drv->close 0x101335b20
cleanup_vector: drv->close 0x1029bcbd0
cleanup_vector: drv->close 0x1012e4430
cleanup_vector: drv->close 0x10127b210
cleanup_vector: drv->close 0x10125b0a8
cleanup_vector: drv->close 0x1029147b8
cleanup_vector: drv->close 0x1031a4438
cleanup_vector: drv->close 0x10317bf20
cleanup_vector: drv->close 0x101a1faa0
cleanup_vector: drv->close 0x103167ea0

This looks (?) like the fonts that don't contain the characters
missing from "Symbola" (which are invalid, so they can be expected to
be missing) and that emacs looked through, are garbage-collected.
Now I go back to the scratch buffer, and see this in the output:

font_open_entity: 0x10280fe30 4313918837 12 => 4322005021
font_open_entity: 0x10280fe30 4347261093 12 => 4347020349
font_open_entity: 0x10280fe30 4315110293 12 => 4346845997
font_open_entity: 0x10280fe30 4346846261 12 => 4346946861
font_open_entity: 0x10280fe30 4346947125 12 => 4322621621
font_open_entity: 0x10280fe30 4322621885 12 => 4314086573
font_open_entity: 0x10280fe30 4314086837 12 => 4314116149
font_open_entity: 0x10280fe30 4314111805 12 => 4314181685
font_open_entity: 0x10280fe30 4314181949 12 => 4314333237
font_open_entity: 0x10280fe30 4314000621 12 => 4314399253
font_open_entity: 0x10280fe30 4314399517 12 => 4314468405
font_open_entity: 0x10280fe30 4314465117 12 => 4314653901
font_open_entity: 0x10280fe30 4314649741 12 => 4314723381
font_open_entity: 0x10280fe30 4314715909 7 => 4314724005
compact_font_cache_entry: dropped 14 entries

The redisplay to go back to the scratch buffer takes a fair amount of
time (several seconds), and it looks like the fonts that don't contain
missing characters are loaded again, examined, and they still don't
contain those characters.

The rest of the session looks like this, where I did some editing.

font_open_entity: 0x10280fe30 4314826397 12 => 4314833973
font_open_entity: 0x10280fe30 4314822261 12 => 4338334365
compact_font_cache_entry: dropped 1 entries
cleanup_vector: drv->close 0x1012d7430
cleanup_vector: drv->close 0x1012d76a0
cleanup_vector: drv->close 0x1012c64c8
cleanup_vector: drv->close 0x101299030
cleanup_vector: drv->close 0x101288210
cleanup_vector: drv->close 0x101278030
cleanup_vector: drv->close 0x101253030
cleanup_vector: drv->close 0x101243030
cleanup_vector: drv->close 0x10123bca8
cleanup_vector: drv->close 0x101a5f8b0
cleanup_vector: drv->close 0x103192528
cleanup_vector: drv->close 0x1031dbaa0
cleanup_vector: drv->close 0x1031c8818
cleanup_vector: drv->close 0x1031a4438
cleanup_vector: drv->close 0x103179b28
cleanup_vector: drv->close 0x1019c9018
font_open_entity: 0x10280fe30 4338666765 12 => 4338670133
compact_font_cache_entry: dropped 1 entries
cleanup_vector: drv->close 0x10295ba98
cleanup_vector: drv->close 0x1012f2430
font_open_entity: 0x10280fe30 4338678941 14 => 4338683037
font_open_entity: 0x10280fe30 4338691229 12 => 4338695325
font_open_entity: 0x10280fe30 4338691349 12 => 4338715805
font_open_entity: 0x10280fe30 4338687245 10 => 4338471477
font_open_entity: 0x10280fe30 4338740325 12 => 4338744093
font_open_entity: 0x10280fe30 4338687245 7 => 4314561589
font_open_entity: 0x10280fe30 4338687365 12 => 4314566357
compact_font_cache_entry: dropped 3 entries

--001a11c23d286f09ee0509e55185
Content-Type: text/plain; charset=US-ASCII; name="bugreport2_patch.txt"
Content-Disposition: attachment; filename="bugreport2_patch.txt"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_i3jck9vh0
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=
--001a11c23d286f09ee0509e55185--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 7 Dec 2014 16:09:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 07 11:09:23 2014
Received: from localhost ([127.0.0.1]:56405 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XxeOg-0001Pv-H7
	for submit <at> debbugs.gnu.org; Sun, 07 Dec 2014 11:09:23 -0500
Received: from mtaout21.012.net.il ([80.179.55.169]:49259)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1XxeOd-0001Pk-NK
 for 19266 <at> debbugs.gnu.org; Sun, 07 Dec 2014 11:09:20 -0500
Received: from conversion-daemon.a-mtaout21.012.net.il by
 a-mtaout21.012.net.il (HyperSendmail v2007.08) id
 <0NG700500Z68NA00@HIDDEN> for 19266 <at> debbugs.gnu.org;
 Sun, 07 Dec 2014 18:09:17 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout21.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NG7005BOZJH8TB0@HIDDEN>;
 Sun, 07 Dec 2014 18:09:17 +0200 (IST)
Date: Sun, 07 Dec 2014 18:09:05 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
Message-id: <83fvcrzbku.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN> <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
 <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: swiesner@HIDDEN, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Date: Sun, 7 Dec 2014 00:50:01 -0500
> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>, 19266 <at> debbugs.gnu.org
> 
> I find that many faces that were previously used get garbage collected
> (I see macfont_close being called from cleanup_vector), but I don't
> know how faces are stored, nor do I understand why they are no longer
> referenced (common sense suggests that they should remain in memory as
> long as the buffer that used them is still there).

Face realizations are not specific to buffers, they are specific to
frames.  So the same face can be realized differently on each frame,
and the same buffer displayed on 2 different frames might look
differently.

OTOH, a given face can be used by many buffers on a frame.

So we cannot easily make a simple one-to-one connection between
buffers and faces they use.

> It seems that the faces are not actively used for displaying the
> buffer, but can be expected to be reused in a short time (e.g.,
> region face or comment face).

You forgot the 'default' face, by far the most reused face.

Also, Emacs consults the face every time it needs to display a
character which uses that face.  So caching is really a necessity.

> Can someone explain where faces are stored and why they are no longer
> referenced, even though the buffer that used them is still active?

Realized faces are stored in the frame's face_cache.  As for the
second part of your question, I hope I clarified the issue at least to
some extent.

> I am not sure if this is related to this bug, but there is a constant
> CLEAR_FACE_CACHE_COUNT (=500) that causes face cache to be cleared
> every 500 redisplays. Does anyone understand why this is really
> necessary?

Because we don't really know when a face is no longer needed.
Tracking that could be more hassle than throwing the cache away from
time to time.

Anyway, if you enlarge that number 100-fold, does the problem go away?
If not, then this is not the cause of your problem.

Also, font objects are stored and maintained differently than faces.
So I'm not sure you are on the right track looking into faces.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 7 Dec 2014 05:50:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 07 00:50:05 2014
Received: from localhost ([127.0.0.1]:55941 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XxUjM-00007B-Sc
	for submit <at> debbugs.gnu.org; Sun, 07 Dec 2014 00:50:05 -0500
Received: from mail-wg0-f45.google.com ([74.125.82.45]:34838)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XxUjK-00006s-Ef
 for 19266 <at> debbugs.gnu.org; Sun, 07 Dec 2014 00:50:03 -0500
Received: by mail-wg0-f45.google.com with SMTP id b13so3905898wgh.18
 for <19266 <at> debbugs.gnu.org>; Sat, 06 Dec 2014 21:50:01 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type:content-transfer-encoding;
 bh=lphL8RUD2axARgdY3voLSFLqOJq5ezhoNoPdC69Wmzw=;
 b=c8JLxsBqiajgzInmSQ2YfPW0C4aaPLY2A03Vfvf0xyORS6x9Mr8rD0+fotTLW46kCf
 nAZJ+QY3vB2iQk/Fb4dlo5kaVIYrHQ5gFFtRvLqwQmg6Vd4Gny7j/zFDcNKQJ1yO7T1t
 Z0cXJQ6JAvPvDrlSmaFYM0T35HNO8dXxeEkSagk8XxX3nQ69Xhy1vtk3WX0WqXImlpmr
 uGhFTtMxGoRSv6sYn7odfjY/KnyRKzTdXqzubb+h7z/4tIM89T/9xX81UxRYmHVhAInO
 YFJboDJcSnD2ZwrUyyTgsWeFuM4XFo0HVJK88UoCfsNBfsebcaj+nAzKubZDNslDYH3E
 ubqw==
MIME-Version: 1.0
X-Received: by 10.180.19.193 with SMTP id h1mr15251913wie.10.1417931401540;
 Sat, 06 Dec 2014 21:50:01 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Sat, 6 Dec 2014 21:50:01 -0800 (PST)
In-Reply-To: <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
 <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
Date: Sun, 7 Dec 2014 00:50:01 -0500
Message-ID: <CACe-pWz-NRXCwh9sdogF6CPRbp_xeHNtP=KBUJgM7ywuWVE2NQ@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Sebastian Wiesner <swiesner@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: Eli Zaretskii <eliz@HIDDEN>, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

I tried looking into this a bit more, and I'm not very familiar with
emacs's internals.

I find that many faces that were previously used get garbage collected
(I see macfont_close being called from cleanup_vector), but I don't
know how faces are stored, nor do I understand why they are no longer
referenced (common sense suggests that they should remain in memory as
long as the buffer that used them is still there). It seems that the
faces are not actively used for displaying the buffer, but can be
expected to be reused in a short time (e.g., region face or comment
face).

Can someone explain where faces are stored and why they are no longer
referenced, even though the buffer that used them is still active?

I am not sure if this is related to this bug, but there is a constant
CLEAR_FACE_CACHE_COUNT (=3D500) that causes face cache to be cleared
every 500 redisplays. Does anyone understand why this is really
necessary? If the fonts/faces are still in use, that seems wasteful,
unless I misunderstand something.

On 4 December 2014 at 05:19, Sebastian Wiesner <swiesner@HIDDEN> wro=
te:
>
>> Am 04.12.2014 um 11:17 schrieb Eli Zaretskii <eliz@HIDDEN>:
>>
>>> From: Sebastian Wiesner <swiesner@HIDDEN>
>>> Date: Thu, 4 Dec 2014 10:55:21 +0100
>>> Cc: Kirill Ignatiev <kirill.ignatiev@HIDDEN>,
>>> 19266 <at> debbugs.gnu.org
>>>
>>>> Please ask those persons to report here directly, and to read the
>>>> responses and discussions.
>>>
>>> So here I am.
>>
>> Thanks for responding.
>>
>>> How do I subscribe to this bug so that I get replies per mail?
>>
>> You will be CC'ed on responses, so no need to subscribe.
>>
>>>> Optimize your font configuration, so that the font search becomes
>>>> faster.
>>>
>>> I do not know about the OP, but I do not have any =E2=80=9Cfont configu=
ration=E2=80=9D.  All that I do is `(set-frame-font "Source Code Pro-13" ni=
l t)'.
>>
>> I meant your system-wide font configuration, not what you do in Emacs.
>
> I don't have that either :)  OS X comes with all sorts of fonts pre-insta=
lled, and I just added some five fonts or so.
>
>>> Besides, I'm no font expert at all, so how am I supposed do =E2=80=9Cop=
timize=E2=80=9D my fonts?
>>
>> Sorry, I don't know that.  If you didn't install too many optional
>> fonts that didn't come with your system, then I think you are already
>> set.  Otherwise, perhaps some OS X expert, here or on some other
>> forum, could help.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 10:20:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 05:20:00 2014
Received: from localhost ([127.0.0.1]:53246 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwTVv-0001lj-Rh
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 05:20:00 -0500
Received: from vega.uberspace.de ([95.143.172.245]:49205)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <swiesner@HIDDEN>) id 1XwTVt-0001lb-IF
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 05:19:58 -0500
Received: (qmail 16786 invoked from network); 4 Dec 2014 10:19:55 -0000
Received: from localhost (HELO ?IPv6:2001:a60:1699:ad01:7d3f:493c:d329:8475?)
 (127.0.0.1) by vega.uberspace.de with SMTP; 4 Dec 2014 10:19:55 -0000
Content-Type: text/plain; charset=utf-8
Mime-Version: 1.0 (Mac OS X Mail 8.1 \(1993\))
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Sebastian Wiesner <swiesner@HIDDEN>
In-Reply-To: <83ppbz4t3f.fsf@HIDDEN>
Date: Thu, 4 Dec 2014 11:19:54 +0100
Content-Transfer-Encoding: quoted-printable
Message-Id: <D08E4035-F1F1-40CD-8412-272FD2D312A0@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
 <83ppbz4t3f.fsf@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
X-Mailer: Apple Mail (2.1993)
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 19266
Cc: kirill.ignatiev@HIDDEN, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)


> Am 04.12.2014 um 11:17 schrieb Eli Zaretskii <eliz@HIDDEN>:
>=20
>> From: Sebastian Wiesner <swiesner@HIDDEN>
>> Date: Thu, 4 Dec 2014 10:55:21 +0100
>> Cc: Kirill Ignatiev <kirill.ignatiev@HIDDEN>,
>> 19266 <at> debbugs.gnu.org
>>=20
>>> Please ask those persons to report here directly, and to read the
>>> responses and discussions.
>>=20
>> So here I am.
>=20
> Thanks for responding.
>=20
>> How do I subscribe to this bug so that I get replies per mail?
>=20
> You will be CC'ed on responses, so no need to subscribe.
>=20
>>> Optimize your font configuration, so that the font search becomes
>>> faster.
>>=20
>> I do not know about the OP, but I do not have any =E2=80=9Cfont =
configuration=E2=80=9D.  All that I do is `(set-frame-font "Source Code =
Pro-13" nil t)'.
>=20
> I meant your system-wide font configuration, not what you do in Emacs.

I don't have that either :)  OS X comes with all sorts of fonts =
pre-installed, and I just added some five fonts or so.

>> Besides, I'm no font expert at all, so how am I supposed do =
=E2=80=9Coptimize=E2=80=9D my fonts?
>=20
> Sorry, I don't know that.  If you didn't install too many optional
> fonts that didn't come with your system, then I think you are already
> set.  Otherwise, perhaps some OS X expert, here or on some other
> forum, could help.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 10:18:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 05:18:01 2014
Received: from localhost ([127.0.0.1]:53242 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwTU1-0001iq-8f
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 05:18:01 -0500
Received: from mtaout20.012.net.il ([80.179.55.166]:41327)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1XwTTz-0001ic-60
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 05:18:00 -0500
Received: from conversion-daemon.a-mtaout20.012.net.il by
 a-mtaout20.012.net.il (HyperSendmail v2007.08) id
 <0NG100300YWQA600@HIDDEN> for 19266 <at> debbugs.gnu.org;
 Thu, 04 Dec 2014 12:17:11 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NG100334Z8M5V30@HIDDEN>;
 Thu, 04 Dec 2014 12:17:11 +0200 (IST)
Date: Thu, 04 Dec 2014 12:17:24 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Sebastian Wiesner <swiesner@HIDDEN>
Message-id: <83ppbz4t3f.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-transfer-encoding: 8BIT
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN> <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: kirill.ignatiev@HIDDEN, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> From: Sebastian Wiesner <swiesner@HIDDEN>
> Date: Thu, 4 Dec 2014 10:55:21 +0100
> Cc: Kirill Ignatiev <kirill.ignatiev@HIDDEN>,
>  19266 <at> debbugs.gnu.org
> 
> > Please ask those persons to report here directly, and to read the
> > responses and discussions.
> 
> So here I am.

Thanks for responding.

> How do I subscribe to this bug so that I get replies per mail?

You will be CC'ed on responses, so no need to subscribe.

> > Optimize your font configuration, so that the font search becomes
> > faster.
> 
> I do not know about the OP, but I do not have any “font configuration”.  All that I do is `(set-frame-font "Source Code Pro-13" nil t)'.

I meant your system-wide font configuration, not what you do in Emacs.

> Besides, I'm no font expert at all, so how am I supposed do “optimize” my fonts?

Sorry, I don't know that.  If you didn't install too many optional
fonts that didn't come with your system, then I think you are already
set.  Otherwise, perhaps some OS X expert, here or on some other
forum, could help.

> Shouldn't Emacs pick reasonable defaults by itself, and remember them?

It should, and it tries to.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 09:55:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 04:55:34 2014
Received: from localhost ([127.0.0.1]:53233 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwT8H-0001BU-Ti
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 04:55:34 -0500
Received: from vega.uberspace.de ([95.143.172.245]:38445)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <swiesner@HIDDEN>) id 1XwT89-0001BD-Ef
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 04:55:31 -0500
Received: (qmail 5723 invoked from network); 4 Dec 2014 09:55:23 -0000
Received: from localhost (HELO hostname.fritz.box) (127.0.0.1)
 by vega.uberspace.de with SMTP; 4 Dec 2014 09:55:23 -0000
Content-Type: text/plain; charset=utf-8
Mime-Version: 1.0 (Mac OS X Mail 8.1 \(1993\))
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Sebastian Wiesner <swiesner@HIDDEN>
In-Reply-To: <83y4qn50ua.fsf@HIDDEN>
Date: Thu, 4 Dec 2014 10:55:21 +0100
Content-Transfer-Encoding: quoted-printable
Message-Id: <957C7241-1F90-42A3-83DE-4696B483C1F0@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
X-Mailer: Apple Mail (2.1993)
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 19266
Cc: Kirill Ignatiev <kirill.ignatiev@HIDDEN>, 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)


> Am 04.12.2014 um 08:30 schrieb Eli Zaretskii <eliz@HIDDEN>:
>=20
>> Date: Thu, 4 Dec 2014 02:13:30 -0500
>> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
>>=20
>> [This is a copy of this question on Emacs.SE:
>> http://emacs.stackexchange.com/questions/4061]
>> At least one other person has the same problem.
>=20
> Please ask those persons to report here directly, and to read the
> responses and discussions.

So here I am.  How do I subscribe to this bug so that I get replies per =
mail?

>> Often when I'm editing a file with many uncommon unicode symbols =
(e.g.,
>> in languages like haskell, julia or c++), and (I think) especially =
with
>> an ornate color theme, I experience delays of maybe about five =
seconds
>> when switching between buffers. Running emacs under lldb show a stack
>> trace below; I get a similar stack trace from running `emacs -Q` and
>> typing `C-h h` (`view-hello-file`), which takes quite a while to =
display
>> the hello file.
>=20
> AFAICT, these delays are due to Emacs searching the system for
> appropriate fonts needed to display those unusual symbols.
>=20
>> What can I do about these window redrawing delays? I am not sure what =
I
>> have misconfigured.
>=20
> Optimize your font configuration, so that the font search becomes
> faster.

I do not know about the OP, but I do not have any =E2=80=9Cfont =
configuration=E2=80=9D.  All that I do is `(set-frame-font "Source Code =
Pro-13" nil t)'.

Besides, I'm no font expert at all, so how am I supposed do =
=E2=80=9Coptimize=E2=80=9D my fonts?  Shouldn't Emacs pick reasonable =
defaults by itself, and remember them?  I don't mean to blame anyone, =
but see, all other applications on my system work fine with my fonts=E2=80=
=A6

>> Does emacs reload all fonts every time I switch to a different frame =
or
>> buffer? It also seems to have a delay sometimes when a previously
>> invisible overlay is shown.
>=20
> Emacs only looks for a font when it needs to display something.  when
> previously invisible portion is about to be displayed, Emacs needs the
> fonts to display it.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 08:20:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 03:20:49 2014
Received: from localhost ([127.0.0.1]:53227 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwRea-0007Kz-9C
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 03:20:49 -0500
Received: from mail-wi0-f175.google.com ([209.85.212.175]:58904)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwReX-0007Kn-LU
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 03:20:46 -0500
Received: by mail-wi0-f175.google.com with SMTP id l15so33991551wiw.8
 for <19266 <at> debbugs.gnu.org>; Thu, 04 Dec 2014 00:20:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=VFu2Jv3c/cJr8WqwggpUipb6xCLoTXHbbrqFeLplio4=;
 b=cbMRe3+q6UNXqTZaV1iYYRfckeu+BZSCb9QyttUS9K+WpitkuqPwBTA7bO+hfabDcp
 DsY7PgnKTQj8pkfhRPZmS7D3byV1jP8eec76JRrI8391UgLkjujrGGY57L2DanHDbjF3
 dOVIv30f/aYzS5hQODFBc0w/Kv+LZhF2pxDVVB/oNxaf48QPxLdS42bw0HdcIJApZ0KY
 P49di85B2kDRSoXh1EmCCv4pq13HTgNLCTnPytsMq8FR3rxgkJlAjNd8+Gor9+PLXS/p
 7C/5wOEJ7PFw3mk6DvgeVCmthL9DSk9Q/FNWdRR5XBZ6IlogJMNPhXm/qSzvW9zqb6Xt
 MlkA==
MIME-Version: 1.0
X-Received: by 10.194.57.43 with SMTP id f11mr13608680wjq.6.1417681245136;
 Thu, 04 Dec 2014 00:20:45 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Thu, 4 Dec 2014 00:20:44 -0800 (PST)
In-Reply-To: <83wq674zav.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <CACe-pWyVjd3TMe-NL=S-brn7hT3OFE0x7TRrbUMyaUC2aXKkKQ@HIDDEN>
 <83wq674zav.fsf@HIDDEN>
Date: Thu, 4 Dec 2014 03:20:44 -0500
Message-ID: <CACe-pWyty4-pPEtP=SLnJQ0m4Ep4X-hA0bhjWzenFLCsCC+Q2g@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: multipart/mixed; boundary=047d7bacc1c805871905095fa35d
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--047d7bacc1c805871905095fa35d
Content-Type: text/plain; charset=UTF-8

On 4 December 2014 at 03:03, Eli Zaretskii <eliz@HIDDEN> wrote:
>> Date: Thu, 4 Dec 2014 02:41:34 -0500
>> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
>> Cc: 19266 <at> debbugs.gnu.org
>
> Emacs releases unused font slots from time to time, which might be the
> reason here.
>
> But this is speculation; a reproducible recipe is required to
> investigate and come up with specifics.  And yes, it could be a bug.

Okay, here's one attempt to reproduce it (sorry about the length). The
idea is to view lots of files, then later viewing a buffer that was
previously displayed causes a delay.

1. Start with -Q.
2. Open file uncommon_symbols.txt (attached). There's a delay but it opens fine.
3. Select the entire file; there is another delay (presumably font for
selected region is loaded separately).
4. C-h h to view hello file. Scroll all the way down with C-v.
5. Mark entire hello file, scroll all the way up from bottom.
6. View src/font.c (in emacs source), scroll all the way down to
render the whole file.
7. Mark the entire file, scroll all the way up, to view the entire
file in selected color.

Now:
8. View uncommon_symbols.txt: no delay.
9. Mark the entire file: no delay again.
10. View hello file: there is a noticeable delay of a few seconds with
the stack trace attached below.

This delay is, I think, identical to what I sometimes experience. Also
the reproduction's length can maybe be reduced somehow. I don't think
viewing three unicode-rich files should lead to such a noticeable
redrawing delay.

It's not so much that the delay is terribly long, it's that it
interrupts typing and normal workflow.

--047d7bacc1c805871905095fa35d
Content-Type: text/plain; charset=US-ASCII; name="uncommon_symbols_bt.txt"
Content-Disposition: attachment; filename="uncommon_symbols_bt.txt"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_i39upgyq0
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--047d7bacc1c805871905095fa35d
Content-Type: text/plain; charset=UTF-8; name="uncommon_symbols.txt"
Content-Disposition: attachment; filename="uncommon_symbols.txt"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_i39upgzd1

Cm5pbCAhOiDCrApuaWwgIT06IOKJogpuaWwgLz06IOKJogpuaWwgPT06IOKJoQpuaWwgJiY6IOKI
pwpuaWwgfHw6IOKIqApuaWwgbm90OiDCrApuaWwgYW5kOiDiiKcKbmlsIG9yOiDiiKgKbmlsID49
OiDiiaUKbmlsIDw9OiDiiaQKbmlsIC0+OiDihpIKbmlsIDwtOiDihpAKbmlsIH46IOKIvApuaWwg
Ojo6IOKItwpuaWwgLT46IOKGkgpuaWwgbnVsbHB0cjog4oiFCm5pbCBudWxsOiDiiIUKbmlsIE5V
TEw6IOKIhQpuaWwgTm9uZTog4oiFCm5pbCB1bmRlZmluZWQ6IOKfggpuaWwgLTw6IOKkmQpuaWwg
Pi06IOKkmgpuaWwgPCo+OiDiipsKbmlsID4+OiDiiasKbmlsIDw8OiDiiaoKbmlsID4+PTog4qSc
Cm5pbCA9PDw6IOKkmwpuaWwgPj4+OiDii5kKbmlsIDw8PDog4ouYCm5pbCAqKio6IOKBggpuaWwg
Kys6IOKnugpuaWwgKysrOiDip7sKbmlsIHx8fDog4qu0Cm5pbCBlbGVtOiDiiIgKbmlsIG5vdEVs
ZW06IOKIiQpuaWwgdW5pb246IOKIqgpuaWwgaW50ZXJzZWN0OiDiiKkKbmlsIG1zdW06IOKKlQpu
aWwgSW50ZWdlcjog4oSkCm5pbCBSYXRpbyBJbnRlZ2VyOiDihJoKbmlsIERvdWJsZTog4oSdCm5p
bCBCb29sOiDwnZS5Cm5pbCBHYW1tYTogzpMKbmlsIERlbHRhOiDOlApuaWwgVGhldGE6IM6YCm5p
bCBMYW1iZGE6IM6bCm5pbCBYaTogzp4KbmlsIFBpOiDOoApuaWwgU2lnbWE6IM6jCm5pbCBVcHNp
bG9uOiDPkgpuaWwgUGhpOiDOpgpuaWwgUHNpOiDOqApuaWwgT21lZ2E6IM6pCm5pbCBhbHBoYTog
zrEKbmlsIGJldGE6IM6yCm5pbCBnYW1tYTogzrMKbmlsIGRlbHRhOiDOtApuaWwgZXBzaWxvbjog
zrUKbmlsIHpldGE6IM62Cm5pbCBldGE6IM63Cm5pbCB0aGV0YTogzrgKbmlsIHZhcnRoZXRhOiDP
kQpuaWwga2FwcGE6IM66Cm5pbCBsYW1iZGE6IM67Cm5pbCBtdTogzrwKbmlsIG51OiDOvQpuaWwg
eGk6IM6+Cm5pbCBwaTogz4AKbmlsIHZhcnBpOiDPlgpuaWwgcmhvOiDPgQpuaWwgdmFycmhvOiDP
sQpuaWwgdmFyc2lnbWE6IM+CCm5pbCBzaWdtYTogz4MKbmlsIHRhdTogz4QKbmlsIHVwc2lsb246
IM+FCm5pbCBwaGk6IM+VCm5pbCB2YXJwaGk6IM+GCm5pbCBjaGk6IM+HCm5pbCBwc2k6IM+ICm5p
bCBvbWVnYTogz4kKbmlsIFJ1c3NpYW5SOiDQrwpuaWwgUnVzc2lhblo6INCXCm5pbCBSdXNzaWFu
Wkg6INCWCm5pbCBSdXNzaWFuRTog0K0K
--047d7bacc1c805871905095fa35d--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 08:03:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 03:03:11 2014
Received: from localhost ([127.0.0.1]:53214 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwRNX-0006tD-EN
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 03:03:11 -0500
Received: from mtaout22.012.net.il ([80.179.55.172]:34324)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1XwRNU-0006t3-FG
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 03:03:09 -0500
Received: from conversion-daemon.a-mtaout22.012.net.il by
 a-mtaout22.012.net.il (HyperSendmail v2007.08) id
 <0NG100D00SXYWL00@HIDDEN> for 19266 <at> debbugs.gnu.org;
 Thu, 04 Dec 2014 10:03:07 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout22.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NG100D56T16G4B0@HIDDEN>;
 Thu, 04 Dec 2014 10:03:07 +0200 (IST)
Date: Thu, 04 Dec 2014 10:03:20 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <CACe-pWyVjd3TMe-NL=S-brn7hT3OFE0x7TRrbUMyaUC2aXKkKQ@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
Message-id: <83wq674zav.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
 <CACe-pWyVjd3TMe-NL=S-brn7hT3OFE0x7TRrbUMyaUC2aXKkKQ@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Date: Thu, 4 Dec 2014 02:41:34 -0500
> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> Cc: 19266 <at> debbugs.gnu.org
> 
> > AFAICT, these delays are due to Emacs searching the system for
> > appropriate fonts needed to display those unusual symbols.
> 
> I understand that this needs to happen once.

It can happen once for each portion of a buffer that was not yet
displayed.

> The description of what triggers the delays is unclear because for me
> it's only reproducible incidentally, during normal work. I have
> fold-mode that hides large portions of text, and a number of frames.
> If I hide some previously-displayed text, go work in another frame,
> then come back and unhide the text, then there is the font-searching
> delay. Something similar happens if I switch to a different buffer,
> then some time later switch back.

Emacs releases unused font slots from time to time, which might be the
reason here.

But this is speculation; a reproducible recipe is required to
investigate and come up with specifics.  And yes, it could be a bug.

> Is it reasonable to expect to keep all recently used fonts in memory
> and not search for them again?

For some value of "recently", yes.  Again, more data is needed to
determine whether this is an Emacs bug or a system configuration
issue.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 07:41:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 02:41:43 2014
Received: from localhost ([127.0.0.1]:53210 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwR2l-0006Ln-5O
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:41:43 -0500
Received: from mail-wi0-f170.google.com ([209.85.212.170]:54467)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwR2d-0006LY-Io
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:41:41 -0500
Received: by mail-wi0-f170.google.com with SMTP id bs8so35441598wib.5
 for <19266 <at> debbugs.gnu.org>; Wed, 03 Dec 2014 23:41:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=+XDnsk6jf0QS4QLCw7GvWSBcFX5gYhFA7BFVBzAUqbA=;
 b=Gb5avEMxIWGc4OVf9LBlbR53F9oDtgbhi1sRczEiwZCYey7iweK5dloDqmm+TcxBJW
 U3x216ITLtwEX1Vqr0W+zSsJmGHqQ5Q7hjXc+MWSkfb2Mh1sMDZ9P8607e8ElTI9qQFu
 id32GJuxClIoRZbPbWVVmK98XrHyu64NCKlrkbqx2i6Yq9Kl7R3RSSfreueM2zs/MVTZ
 2n5A0UYUdAV47rdn1uBor+KSyZs0qe8v6m73Kr6ImWun+4dddi5PRG9Lamo1FthgV3jS
 gFXodvgtwFNawc2CGKcrq8bIfG0hevQ62RX0bRuYwNH9yb7NHtIBN2y/NRjVTOdnAk8j
 uaYA==
MIME-Version: 1.0
X-Received: by 10.180.88.33 with SMTP id bd1mr105381979wib.10.1417678894623;
 Wed, 03 Dec 2014 23:41:34 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Wed, 3 Dec 2014 23:41:34 -0800 (PST)
In-Reply-To: <83y4qn50ua.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
 <83y4qn50ua.fsf@HIDDEN>
Date: Thu, 4 Dec 2014 02:41:34 -0500
Message-ID: <CACe-pWyVjd3TMe-NL=S-brn7hT3OFE0x7TRrbUMyaUC2aXKkKQ@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 19266
Cc: 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On 4 December 2014 at 02:30, Eli Zaretskii <eliz@HIDDEN> wrote:
>> Date: Thu, 4 Dec 2014 02:13:30 -0500
>> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
>>
>> [This is a copy of this question on Emacs.SE:
>> http://emacs.stackexchange.com/questions/4061]
>> At least one other person has the same problem.
>
> Please ask those persons to report here directly, and to read the
> responses and discussions.
>
>> Often when I'm editing a file with many uncommon unicode symbols (e.g.,
>> in languages like haskell, julia or c++), and (I think) especially with
>> an ornate color theme, I experience delays of maybe about five seconds
>> when switching between buffers. Running emacs under lldb show a stack
>> trace below; I get a similar stack trace from running `emacs -Q` and
>> typing `C-h h` (`view-hello-file`), which takes quite a while to display
>> the hello file.
>
> AFAICT, these delays are due to Emacs searching the system for
> appropriate fonts needed to display those unusual symbols.

I understand that this needs to happen once. Is it reasonable that the
delay happens many times during normal editing?

The description of what triggers the delays is unclear because for me
it's only reproducible incidentally, during normal work. I have
fold-mode that hides large portions of text, and a number of frames.
If I hide some previously-displayed text, go work in another frame,
then come back and unhide the text, then there is the font-searching
delay. Something similar happens if I switch to a different buffer,
then some time later switch back.

>> What can I do about these window redrawing delays? I am not sure what I
>> have misconfigured.
>
> Optimize your font configuration, so that the font search becomes
> faster.
>
>> Does emacs reload all fonts every time I switch to a different frame or
>> buffer? It also seems to have a delay sometimes when a previously
>> invisible overlay is shown.
>
> Emacs only looks for a font when it needs to display something.  when
> previously invisible portion is about to be displayed, Emacs needs the
> fonts to display it.

The reason I suspect this may be an actual bug is not that the delay
happens at all, but rather that it happens quite often, and the text
that causes the search for fonts used to be displayed only a short
time ago.

That said, I'm not familiar with how emacs manages fonts. Is it
reasonable to expect to keep all recently used fonts in memory and not
search for them again?

Thanks for the very quick reply.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at 19266 <at> debbugs.gnu.org:


Received: (at 19266) by debbugs.gnu.org; 4 Dec 2014 07:29:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 02:29:56 2014
Received: from localhost ([127.0.0.1]:53202 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwQrM-00060k-D3
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:29:56 -0500
Received: from mtaout25.012.net.il ([80.179.55.181]:41192)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eliz@HIDDEN>) id 1XwQrJ-00060b-K6
 for 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:29:54 -0500
Received: from conversion-daemon.mtaout25.012.net.il by mtaout25.012.net.il
 (HyperSendmail v2007.08) id <0NG100J00R5QCN00@HIDDEN> for
 19266 <at> debbugs.gnu.org; Thu, 04 Dec 2014 09:25:33 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by mtaout25.012.net.il
 (HyperSendmail v2007.08) with ESMTPA id
 <0NG100DDRRALRM60@HIDDEN>; Thu, 04 Dec 2014 09:25:33 +0200 (IST)
Date: Thu, 04 Dec 2014 09:30:05 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#19266: 24.4; Font-related window redrawing delays on OS X
In-reply-to: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
Message-id: <83y4qn50ua.fsf@HIDDEN>
References: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 19266
Cc: 19266 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

> Date: Thu, 4 Dec 2014 02:13:30 -0500
> From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
> 
> [This is a copy of this question on Emacs.SE:
> http://emacs.stackexchange.com/questions/4061]
> At least one other person has the same problem.

Please ask those persons to report here directly, and to read the
responses and discussions.

> Often when I'm editing a file with many uncommon unicode symbols (e.g.,
> in languages like haskell, julia or c++), and (I think) especially with
> an ornate color theme, I experience delays of maybe about five seconds
> when switching between buffers. Running emacs under lldb show a stack
> trace below; I get a similar stack trace from running `emacs -Q` and
> typing `C-h h` (`view-hello-file`), which takes quite a while to display
> the hello file.

AFAICT, these delays are due to Emacs searching the system for
appropriate fonts needed to display those unusual symbols.

> What can I do about these window redrawing delays? I am not sure what I
> have misconfigured.

Optimize your font configuration, so that the font search becomes
faster.

> Does emacs reload all fonts every time I switch to a different frame or
> buffer? It also seems to have a delay sometimes when a previously
> invisible overlay is shown.

Emacs only looks for a font when it needs to display something.  when
previously invisible portion is about to be displayed, Emacs needs the
fonts to display it.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 4 Dec 2014 07:13:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 04 02:13:54 2014
Received: from localhost ([127.0.0.1]:53195 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XwQbn-0005am-A9
	for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:13:53 -0500
Received: from eggs.gnu.org ([208.118.235.92]:47828)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwQbj-0005aa-3h
 for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:13:50 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwQbe-0004v6-9I
 for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:13:46 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:54430)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwQbe-0004up-6I
 for submit <at> debbugs.gnu.org; Thu, 04 Dec 2014 02:13:42 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:49531)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwQbZ-0005XL-4M
 for bug-gnu-emacs@HIDDEN; Thu, 04 Dec 2014 02:13:42 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwQbU-0004tC-O2
 for bug-gnu-emacs@HIDDEN; Thu, 04 Dec 2014 02:13:37 -0500
Received: from mail-wg0-x229.google.com ([2a00:1450:400c:c00::229]:60274)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <kirill.ignatiev@HIDDEN>) id 1XwQbU-0004sh-4Q
 for bug-gnu-emacs@HIDDEN; Thu, 04 Dec 2014 02:13:32 -0500
Received: by mail-wg0-f41.google.com with SMTP id y19so21803385wgg.28
 for <bug-gnu-emacs@HIDDEN>; Wed, 03 Dec 2014 23:13:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:date:message-id:subject:from:to:content-type;
 bh=SnzLDBOkHJ4HBn8lr47fdom+vhON2h+vuDN9NJh/BkI=;
 b=eSUo23RchGbaZv0rNmQPugnVithEUk0rJM8PaZc+YGVL88YrbOLXImyknC6LcDfGfp
 HTx2CPPq8xBma5P2/1jnijEpn4ee+sYlwrtkYyDGADic6pMIPqRzJCbPGp1vv9pqlfQ0
 My5xq+TLN01BMaHj1z2GElOiTdM6GtZj84bGXP+sK9GyK22zNgRyMhGnEhCUBmIZnUd+
 iuvf+9OJ2hMKYD/+aiUNPV3FLvEz+GTeZCDXwbHtaRQXtsGK2eyV8HiHDa7iFNVvTxSE
 oPwLoi7WjdGYr7dPpn1WL1ZR8CgfF2R4fTv93toVYouabkzBUR53BMWhs6ph9ztUgsPj
 0Ubw==
MIME-Version: 1.0
X-Received: by 10.181.13.242 with SMTP id fb18mr22811591wid.1.1417677211347;
 Wed, 03 Dec 2014 23:13:31 -0800 (PST)
Received: by 10.27.87.87 with HTTP; Wed, 3 Dec 2014 23:13:30 -0800 (PST)
Date: Thu, 4 Dec 2014 02:13:30 -0500
Message-ID: <CACe-pWyU-Rf_nH7WBGfENDCQ-c2O5zz3T=yDDg-ZdQ9rWV6vCA@HIDDEN>
Subject: 24.4; Font-related window redrawing delays on OS X
From: Kirill Ignatiev <kirill.ignatiev@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Content-Type: multipart/mixed; boundary=f46d043c05c497313305095eb244
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

--f46d043c05c497313305095eb244
Content-Type: text/plain; charset=UTF-8



--f46d043c05c497313305095eb244
Content-Type: text/plain; charset=US-ASCII; name="bugreport.txt"
Content-Disposition: attachment; filename="bugreport.txt"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_i39sbsu30
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--f46d043c05c497313305095eb244--




Acknowledgement sent to Kirill Ignatiev <kirill.ignatiev@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#19266; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 25 Nov 2019 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.